/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.persistent;

import lombok.Getter;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.function.Consumer;

@Getter
public class Bauserver extends Subserver {
    private static final Map<UUID, Bauserver> servers = new HashMap<>();
    public static Bauserver get(UUID owner) {
        synchronized (servers) {
            return servers.get(owner);
        }
    }

    private final UUID owner;

    public Bauserver(String serverName, UUID owner, int port, ProcessBuilder processBuilder, Runnable shutdownCallback){
        this(serverName, owner, port, processBuilder, shutdownCallback, null);
    }

    public Bauserver(String serverName, UUID owner, int port, ProcessBuilder processBuilder, Runnable shutdownCallback, Consumer<Exception> failureCallback){
        super(serverName, port, processBuilder, shutdownCallback, failureCallback);
        this.owner = owner;

        synchronized (servers) {
            servers.put(owner, this);
        }
    }

    @Override
    protected void unregister() {
        synchronized (servers) {
            servers.remove(owner);
        }
        super.unregister();
    }
}
